#{extends 'borderNG.html' /}
#{set 'titleHead'}
&{'doc.penawaran_peserta'}
#{/set}

<ol class="breadcrumb" style="background-color: #d9534f !important;">
    <li><a href="@{BerandaCtr.nonLelang()}" >&{'doc.home'}</a></li>
    <li class="active"><a href="@{nonlelang.PengadaanLCtr.view(pl?.lls_id)}">&{'doc.info_paket'}</a></li>
    <li class="active">&{'doc.penawaran_peserta'}</li>
</ol>

#{tabmenuPenawaranPL pl.lls_id/}

<div class="content">
    <div id="alert"></div>

#{if checklistPlList}
    #{list items:checklistPlList, as:'checklist'}

        <div class="card card-default">
            <div class="card-header"><strong>${checklist.ckm_id != 36 ? checklist.getChecklist_master().ckm_nama : checklist.chk_nama}</strong></div>
            <div class="card-body">
                <div id="alert-upload-${checklist.chk_id}" style="width: auto;"></div>
                <ul id="files-${checklist.chk_id}" class="list-group files" style="width: 500px;">
                    #{list items:checklist.getListDokPenawaranPlByPsrAndJenis(pesertaPl.psr_id,dokJenis), as:'penawaran'}
                        <li class="list-group-item">
                            <a href="${penawaran?.blob?.getDownloadUrl()}"><i class="fa fa-download"></i> &nbsp; ${penawaran?.blob?.blb_nama_file}</a> <abbr title="Tanggal Kirim" class="initialism">
                            (${penawaran?.blob?.blb_date_time?.formatDateTime()})</abbr>

                            <a href="javascript:void(0)" id="${penawaran?.dok_id}" style="float: right;"
                               class="btn btn-danger btn-sm" name="removeBtn" chk="${checklist.chk_id}">
                                <i class="fa fa-close"></i>
                            </a>

                        </li>
                    #{/list}
                </ul>
                <div class="btn btn-success fileinput-button">
                    <i class="glyphicon glyphicon-plus"></i>
                    <span>&{'doc.upload'}</span>
                    <input id="upload-${checklist.chk_id}" type="file" name="file"
                           onclick="upload('${checklist.chk_id}');">
                </div>
                <br /><br />
                <div id="progress-${checklist.chk_id}" class="progress" style="display: none;">
                    <div class="progress-bar progress-bar-success"></div>
                </div>
                <div id="alert-upload" style="margin-top: 10px;"></div>
            </div>
        </div>

    #{/list}
#{/if}

#{if editable}
    <table id="template" class="table table-sm">
        <tr>
            <th>
                <button class="btn btn-default btn-sm" onclick="createAndDownloadTemplate();">
                    <i class="glyphicon glyphicon-download"></i> &{'doc.template_penawaran'}
                </button>
                <a class="btn btn-default btn-sm" href="#" onclick="$('#rincian_upload').click()" id="uploadHPS">&{'doc.upload_penawaran'}</a>
            </th>
            <th>
                <input type="file" name="file" id="rincian_upload" class="form-control" style="display:none"
                       placeholder="Upload Rincian HPS" #{if !editable} disabled #{/if}>
            </th>
        </tr>
    </table>
#{/if}

    <div class="bs-callout bs-callout-info">
        <b>&{'doc.petunjuk_upload_penawaran'}:</b><br/>
        &{'doc.petunjuk_upload_penawaran_1'}<br/>
        &{'doc.petunjuk_upload_penawaran_2'}
        <br/><br/>
        <b>&{'doc.petunjuk_pengisian_penawaran'}</b><br/>
        &{'doc.petunjuk_pengisian_penawaran_1'}<br/>
        &{'doc.petunjuk_pengisian_penawaran_2'}<br/>
        &{'doc.petunjuk_pengisian_penawaran_3'}
        <br /><br />
        <b>&{'doc.petunjuk_pengisian_tabel'}</b><br />
        &{'doc.untuk_menamah_baris'}<br />
    </div>

    <div class="clearfix"></div>
*{<div class="bs-callout bs-callout-info">
    &{'doc.untuk_menamah_baris'}
    </div>}*
    <div id = "rincian-area">
        <div id="tbl-rincian" style="margin:20px;"></div>
        <div class="float-right">
            <table id="rekap" class="table table-sm" style="width:300px;margin-right:50px;">
                <tr>
                    <th style="text-align:right">&{'doc.total_nilai'}</th>
                    <th id="total_hps" style="text-align:right"></th>
                </tr>
            </table>
        </div>
        *{#{if !pl.pemilihan}}*
            *{<div class="form-check-inline">}*
                *{<label><input type="checkbox" id="fixed" name="fixed" value="false" #{if !fixed} checked #{/if} #{if !editable}}*
                              *{disabled="disabled" #{/if}/>}*
                    *{&{'doc.peserta_boleh_mengubah'}</label>}*
            *{</div>}*
        *{#{/if}}*
            <div class="clearfix"></div>
        #{if editable}
            #{authenticityToken /}
            <button type="button" name="simpan" id="simpan" class="btn btn-success">
                <i class="fa fa-save"></i>
                &{'doc.btn_simpan'}
            </button>
        #{/if}
        #{backButton action:@nonlelang.PengadaanLCtr.view(pl.lls_id) /}

    </div>
    <div id = "btn-rincian-area">
        #{backButton action:@nonlelang.PengadaanLCtr.view(pl.lls_id) /}
    </div>
</div>

#{set 'css_custom' }
    #{if editable}
    <link href="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/css/jquery.fileupload.min.css" rel="stylesheet" type="text/css">
    #{/if}
<link href="#{assets '/handsontable/handsontable.full.min.css'/}" rel="stylesheet" type="text/css">
#{/set}


#{set 'custom_script'}
    #{if editable}
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/vendor/jquery.ui.widget.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.iframe-transport.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.fileupload.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.fileupload-process.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.fileupload-validate.min.js"></script>
    #{/if}
<script type="text/javascript" src="#{assets '/handsontable/handsontable.full.min.js'/}"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/PapaParse/5.1.0/papaparse.min.js"></script>

<script type="text/javascript" src="https://unpkg.com/xlsx@0.15.6/dist/jszip.js"></script>
<script type="text/javascript" src="https://unpkg.com/xlsx@0.15.6/dist/xlsx.min.js"></script>

<script type="text/javascript" src="#{assets '/js/FileSaver.min.js'/}"></script>

<script type="text/javascript">

    var data = ${data?.raw()};
    var dataHps = ${dataHps?.raw()};
    var interval = 2 * 60 * 1000; // 2 menit
    var total = 0;
    var fixed = true;
    var length = '${data.length()}';
    var pagu = '${nilai_pagu}';
    //var sudah_upload = Boolean(${isSudahUpload});

    var X = XLSX;

    var is_valid = true;

    $( document ).ready(function() {

        $('#rincian_upload').fileupload();

        if (length == 0)
            $('#rincian-area').hide();
        else
            $('#btn-rincian-area').hide();
    });

    var is_valid = false;

    function upload(chk_id) {
        var url = #{jsRoute @nonlelang.DokumenPlCtr.uploadPenawaranHargaKonstruksi(pesertaPl?.lls_id, pesertaPl?.psr_id, ':chk_id') /};

        $('#upload-'+chk_id).fileupload({
            url: url.url({chk_id:chk_id}),
            dataType: 'json',
            acceptFileTypes: /(\.|\/)(txt|doc|docx|xls|xlsx|pdf|gif|jpe?g|png|zip|rar|rtf)$/i,
            done: function (e, data) {
                $.each(data.result.files, function (index, file,) {
                    var content = '<a href="' + file.download_url + '"><i class="fa fa-download"></i>' +
                            '&nbsp; ' + file.name + '</a> - ' + file.size + ' (' + file.upload_date + ')' +
                            ' <a href="javascript:void(0)" id="'+data.result.dok_id+'" style="float: right;" chk="'+data.result.chk_id+'"' +
                            'class="btn btn-danger btn-sm" name="removeBtn"><i class="fa fa-close"></i></a>';
                    $('<li/>').addClass('list-group-item').html(content).appendTo('#files-'+chk_id);
                });
                $('#progress-'+chk_id).hide();
            },
            progressall: function (e, data) {
                var progress = parseInt(data.loaded / data.total * 100, 10);
                $('#progress-'+chk_id).show();
                $('#progress-'+chk_id+' .progress-bar').css(
                        'width',
                        progress + '%'
                );
            }
        }).on('fileuploadprocessalways', function (e, data) {
            var file = data.files[data.index];
            if (data.files.error && file.error) {
                var msg = file.name + ' - ' + file.error
                $('#alert-upload').attr('class', 'alert alert-danger').html(msg)
            }
        }).prop('disabled', !$.support.fileInput).parent().addClass($.support.fileInput ? undefined : 'disabled');
    };

    $(document).on('click', "[name = 'removeBtn']", function () {
        var id = $(this).attr('id');
        var chk = $(this).attr('chk');
        var parent = $(this).parent()
        var source = #{jsRoute @nonlelang.DokumenPlCtr.hapusPenawaranHargaKonstruksi() /};
        $.ajax({
            type: 'POST',
            url: source.url(),
            data: {'dok_id': id},
            success: function (result) {
                if (result.status === 'ok') {
                    $('#alert-upload-' + chk).html('<div class="alert alert-success" role="alert">&{'flash.file_telah_terhapus'}</div>');
                    parent.remove()
                } else {
                    $('#alert-upload-' + chk).html('<div class="alert alert-success" role="alert">' + result.message + '</div>');
                }
            },
            error: function () {
                $('#alert-upload-'+chk).html('<div class="alert alert-danger" role="alert">File tidak bisa dihapus</div>');
            }
        })
    });

    $('#rincian_upload').on('change', function (e) {

        var files = e.target.files;
        var f = files[0];
        {
            var reader = new FileReader();
            var name = f.name;
            reader.onload = function (e) {
                var data = e.target.result;
                $('#alert').attr('class','');
                $('#alert').empty();
                try {

                    var wb = X.read(data, {type: 'binary'});
                    var output = to_json(wb);
                    var res = output['rincian-penawaran'];
                    var total_penawaran = 0;
                    for (var i = 0; i < dataHps.length; i++) {
                        total_penawaran = total_penawaran + Number(res[i]['Harga Penawaran']);
                    }
                    if (total_penawaran <= pagu) {
                        process_wb(wb);
                        is_valid = true;
                    } else{
                        $('#alert').attr('class', 'alert alert-danger')
                                .html('<i class="fa fa-times" aria-hidden="true">' +
                                        '</i>&nbsp;Gagal Upload Dokumen Penawaran : Total Penawaran melebihi Pagu');
                    }
                }catch(err){
                    alert("Format file yang Anda upload tidak valid.");
                }
            };

            if (!is_valid && length == 0) {
                $('#rincian-area').hide();
                $('#btn-rincian-area').show();
            }
            reader.readAsBinaryString(f);
        }

    });

    function process_wb(wb) {
        var output = to_json(wb);
        var res = output['rincian-penawaran'];
        var obj = [];
        for (var i = 0; i < dataHps.length; i++) {

            var totalharga = 0;
            var pajak = 0;

            if (!parseInt(dataHps[i].vol, 10)) {
                data2[i].vol = 0;
            } else {
                totalharga = dataHps[i].vol * res[i]['Harga Penawaran'];
            }

            // if (!parseInt(dataHps[i].vol2, 10)) {
            //     //console.log("vol2 not null");
            //     dataHps[i].vol2 = 1;
            // }
            // if (dataHps[i].vol2 > 0) {
            //     //console.log("if 2 :"+parseInt(res[i][2], 10))
            //     totalharga = dataHps[i].vol * dataHps[i].vol2 * res[i]['Harga Penawaran'];
            // }

            //pajak ga boleh null
            if (!parseInt(res[i]['Pajak(%)'], 10)) {
                res[i]['Pajak(%)'] = 0;
            }
            if (res[i]['Pajak(%)'] > 0) {
                pajak = (res[i]['Pajak(%)'] / 100) * totalharga;
                totalharga += pajak;
            }

            obj.push({
                item: replaceChar(dataHps[i].item),
                unit: replaceChar(dataHps[i].unit),
                vol: dataHps[i].vol,
                // unit2: replaceChar(dataHps[i].unit2),
                // vol2: dataHps[i].vol2,
                harga: res[i]['Harga Penawaran'],
                pajak: res[i]['Pajak(%)'],
                //asep:total to auto
                //total_harga:res[i][7],
                total: pajak,
                total_harga: totalharga,
                keterangan: replaceChar(dataHps[i].keterangan)
            })

        }
        data = obj;
        $("#tbl-rincian").handsontable("loadData", obj);
        summary();
    }

    function to_json(workbook) {
        var result = {};
        workbook.SheetNames.forEach(function (sheetName) {
            var roa = X.utils.sheet_to_row_object_array(workbook.Sheets[sheetName]);
            if (roa.length > 0) {
                result[sheetName] = roa;
            }
        });
        return result;
    }

    function replaceChar(str) {
        var strs = "";
        strs += str;
        return strs.replace(/[^a-zA-Z0-9.,!@#$%&@*()-+=/\-\s ]/g, "");
    }
    function summary() {
        var data = $("#tbl-rincian").data('handsontable').getData();
        var total_hps = 0;
        var total = 0;
        for (var i = 0; i < data.length; i++) {
            if (data[i].total_harga)
                total += parseFloat(data[i].total_harga);
        }
	    if (total > 0) {
		    total_hps = parseFloat(total);
	    }
	    $("#rekap").find("#total_hps").text(toRupiah(rounded2Decimal(total_hps)));
    }

    if (data.length == 0) {
        data.push({
            item: "",
            unit: "",
            vol: 1,
            unit2: "",
            vol2: 1,
            harga: 0,
            pajak: 10,
            total: 0,
            total_harga: 0,
            keterangan: ""
        });
    }
    
    var language = {
			delimiters: {
				thousands: '.',
				decimal: ','
			},
			abbreviations: {
				thousand: 'rb',
				million: 'jt',
				billion: 'M',
				trillion: 'B'
			},
			ordinal: function (number) {
				var b = number % 10;
				return (~~(number % 100 / 10) ===1) ? 'th' : (b === 1) ? 'st' : (b === 2) ? 'nd' : (b === 3) ? 'rd' : 'th';
			},
			currency: {
				symbol: 'Rp.'
			}
		};
	
	// Node
	if (typeof module !== 'undefined' && module.exports) {
		module.exports = language;
	}

	// Browser
	if (typeof window !== 'undefined' && this.numeral && this.numeral.language) {
		this.numeral.language('id', language);
	}

	
    $("#tbl-rincian").handsontable({
        rowHeaders: true,
        dataSchema: {
            item: "",
            unit: "",
            vol: 1,
            unit2: "",
            vol2: 1,
            harga: 0,
            pajak: 10,
            total: 0,
            total_harga: 0,
            keterangan: ""
        },
        data: data,
        #{if editable}
            contextMenu: {
                items: {
                    "undo": {name: "Undo"},
                    "redo": {name: "Redo"}
                }
            },
        #{/if}
            
            	    
            
       	language: 'id',
        columns: [{data: 'item', width: 200, title: 'Jenis Barang/Jasa'},
            {data: 'unit', width: 100, title: 'Satuan'},
            {data: 'vol', type: 'numeric', format: '0,0.00', width: 50, title: 'Vol'},
            // {data: 'unit2', width: 100, title: 'Satuan 2'},
            // {data: 'vol2', type: 'numeric', format: '0,0.00', width: 50, title: 'Vol 2'},
            {data: 'harga', type: 'numeric', format: '0,0.00', width: 100, title: 'Harga Penawaran'},
            {data: 'pajak', type: 'numeric', format: '0,0.00', width: 60, title: 'Pajak (%)', dataSchema: 10},
            {data: 'total', type: 'numeric', format: '0,0.00', width: 100, title: 'Nilai Pajak (Rp.)'},
            {data: 'total_harga', type: 'numeric', format: '0,0.00', width: 100, title: 'Total'},
            {data: 'keterangan', width: 250, title: 'Keterangan'}],


        cells: function (row, col, prop) {
            var cellProperties = {};
            #{if editable}
                if (col !=3) {
                    cellProperties.readOnly = true;
                }
                if (data[row] && (col == 2 || col == 4 || col == 3)) {
                    var total = 0;
                    var tax = 0
                    if (data[row].vol <= 0)
                        data[row].vol = 1.0;

                    //if (row == 0)
                    //console.log(data[row])
                    if (data[row].harga > 0)
                        total = data[row].harga;
                    if (data[row].vol > 0) {
                        data[row].vol = rounded2Decimal(parseFloat(data[row].vol));
                        total = total * data[row].vol;
                    }
                    if (data[row].pajak > 0)
                        tax = ((total * data[row].pajak) / 100);
                    else
                        data[row].pajak = 0;
                    total = total + tax;
                    data[row].total = tax;
                    if (total >= 0) {
                        data[row].total_harga = rounded2Decimal(total);
                    }
                }
                if (data[row] && (col == 1 || col == 2 || col == 7)) {
                    data[row].item = replaceChar(data[row].item);
                    data[row].unit = replaceChar(data[row].unit);
                    data[row].keterangan = replaceChar(data[row].keterangan);
                }
            #{/if}
            #{else}
                cellProperties.readOnly = true;
            #{/else}
            return cellProperties;
        },
        afterChange: function (change, source) {
            summary();
        },
        afterRemoveRow: function () {
            summary();
        },
    });
    $("#fixed").on('change', function () {
        fixed = this.checked ? false : true;
    });
        {#{if editable}
        $("#simpan").click(function () {
            if (toNumber($("#rekap").find("#total_hps").text()) > 0) {
                autosave();
            } else {
                $('#alert').html('<div class="alert alert-danger">Total bernilai 0, periksa kembali rincian HPS Anda!</div>');
            }
        });

        function autosave() {
            var postdata = $("#tbl-rincian").data('handsontable').getData();
            var token = $("input[name='authenticityToken']").val();
            $.ajax({
                url: '@{nonlelang.DokumenPlCtr.penawaranSubmit(pesertaPl.psr_id)}',
                data: {"authenticityToken": token, 'model': {
                    "data": JSON.stringify(postdata),
                    "fixed": fixed}
                    },
                dataType: 'json',
                method: 'POST',
                success: function (res) {

                    $('#alert').attr('class','');
                    $('#alert').empty();

                    if (res.result === 'ok') {
                        $('#alert').html('<div class="alert alert-success">Data berhasil tersimpan</div>');
                    } else {
                        $('#alert').html('<div class="alert alert-danger">Data gagal tersimpan : ' + res.result + '</div>');
                    }
                },
                error: function () {
                    $('#alert').html('<div class="alert alert-danger">' +
                            'Data gagal tersimpan karena ada kendala jaringan/server' +
                            '</div>');
                }
            });
        }
        //setInterval(autosave, interval);
        #{/if}}

    function createAndDownloadTemplate(){

        var wb = {};
        wb.Sheets = {};
        wb.SheetNames = [];

        var wopts = { bookType: 'xlsx', bookSST: false, type: 'binary' };

        var ws = { '!ref': "A1:H220" };

        ws['A1'] = { h: "Jenis Barang/Jasa", r: "<t>Jenis Barang/Jasa</t>", t: "Jenis Barang/Jasa", v: "Jenis Barang/Jasa", w: "Jenis Barang/Jasa" }
        ws['B1'] = { h: "Satuan", r: "<t>Satuan</t>", t: "Satuan", v: "Satuan", w: "Satuan" }
        ws['C1'] = { h: "Vol", r: "<t>Vol</t>", t: "Vol", v: "Vol", w: "Vol" }
        // ws['D1'] = { h: "Satuan2", r: "<t>Satuan2</t>", t: "Satuan2", v: "Satuan2", w: "Satuan2" }
        // ws['E1'] = { h: "Vol2", r: "<t>Vol2</t>", t: "Vol2", v: "Vol2", w: "Vol2" }
        ws['D1'] = { h: "Harga Penawaran", r: "<t>Harga Penawaran</t>", t: "Harga Penawaran", v: "Harga Penawaran", w: "Harga Penawaran" }
        ws['E1'] = { h: "Pajak(%)", r: "<t>Pajak</t>", t: "Pajak(%)", v: "Pajak(%)", w: "Pajak(%)" }
        ws['F1'] = { h: "Keterangan", r: "<t>Keterangan</t>", t: "Keterangan", v: "Keterangan", w: "Keterangan" }

        for(var i = 0; i < dataHps.length; i++){
            var cell = i+2;
            ws['A'+cell] = { h: dataHps[i].item, r: "<t>dataHps[i].item</t>", t: dataHps[i].item, v: dataHps[i].item, w: dataHps[i].item }
            ws['B'+cell] = { h: dataHps[i].unit, r: "<t>dataHps[i].unit</t>", t: dataHps[i].unit, v: dataHps[i].unit, w: dataHps[i].unit }
            ws['C'+cell] = { h: dataHps[i].vol, r: "<t>dataHps[i].vol</t>", t: dataHps[i].vol, v: dataHps[i].vol, w: dataHps[i].vol }
            // ws['D'+cell] = { h: dataHps[i].unit2, r: "<t>dataHps[i].unit2</t>", t: dataHps[i].unit2, v: dataHps[i].unit2, w: dataHps[i].unit2 }
            // ws['E'+cell] = { h: dataHps[i].vol2, r: "<t>dataHps[i].vol2</t>", t: dataHps[i].vol2, v: dataHps[i].vol2, w: dataHps[i].vol2 }
            //ws['F'+cell] = { h: "Harga Penawaran", r: "<t>Harga Penawaran</t>", t: "Harga Penawaran", v: "Harga Penawaran", w: "Harga Penawaran" }
            ws['E'+cell] = { h: dataHps[i].pajak, r: "<t>dataHps[i].pajak</t>", t: dataHps[i].pajak, v: dataHps[i].pajak, w: dataHps[i].pajak }
            ws['F'+cell] = { h: dataHps[i].keterangan, r: "<t>dataHps[i].keterangan</t>", t: dataHps[i].keterangan, v: dataHps[i].keterangan, w: dataHps[i].keterangan }

        }


        wb.SheetNames.push('rincian-penawaran');
        wb.Sheets['rincian-penawaran'] = ws;

        var wbout = XLSX.write(wb, wopts);

        function s2ab(s) {
            var buf = new ArrayBuffer(s.length);
            var view = new Uint8Array(buf);
            for (var i = 0; i != s.length; ++i) view[i] = s.charCodeAt(i) & 0xFF;
            return buf;
        }

        saveAs(new Blob([s2ab(wbout)], { type: "" }), "rincian-penawaran.xlsx");
    }

</script>
#{/set}